#include <unistd.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <fcntl.h>
#include <signal.h>
#include "CFCommand.H"
#include "StrUtil.H"

#include "Logger.H"
extern Logger logger;

extern const char *CURFLOO_VER;

unsigned long CFCommand::MSecsToComplete=5500000;

CFCommand::CFCommand(YahooProto &yp, Menu &menu, const string fname):
	_yp(yp),
	_menu(menu) {
	
	_commandlist=new FStrPairList(fname.c_str(),true);
}

CFCommand::~CFCommand() {
	delete (_commandlist);
}

int CFCommand::handleCommand(const string &command) {
	int
		attempts=0,
		max_attempt=256;
	char
		*ptr,		
		*nlr,		
		lazy_hack[]=" ", //EVIL EVIL hack!
		inp[513];

	strncpy(inp,command.c_str(),512);
	inp[512]=0;
	while (attempts++ < max_attempt) {
		if (!strcasecmp(inp,"/quit")) {
			_menu.handleMenuItem(CFMENU_QUIT);
			return 0;
		}
		if (inp[0]=='!') {
			bool
				local=false;
			string
				result,
				command;

			if (inp[1]=='!') {
				command=inp+2;
				local=true;
			}
			else
				command=inp+1;
			handleExecCommand(command,result);
			if (local) {
				StrList
					slist(false);
				slist.add(result);
				_menu.handleMenuItem(CFMENU_OLOCALEXEC,slist);
				return 0;
			}
			strncpy(inp,result.c_str(),512);

			nlr = strrchr(inp,'\n');	// BEM
			if (nlr != NULL)		// BEM
				*nlr = '\0';		// BEM

			break;
		}
		if (!strncasecmp(inp,"/ver",4)) {
			sprintf(inp, "is using Curfloo v%s\n "
				"(%c[lm http://slackattack.ath.cx:1500/curfloo.html %c[xlm)",	//adjust for new download area 19-Oct.-2003 15:51
				CURFLOO_VER,0x1B,0x1B);
			_yp.sendEmote(inp);
			return 0;
		}
		if (!strncasecmp(inp,"/help",5)) {
			_menu.handleMenuItem(CFMENU_HELP);
			return 0;
		}
		if (!strncasecmp(inp,"/about",6)) {
			_menu.handleMenuItem(CFMENU_ABOUT);
			return 0;
		}
		if (!strncasecmp(inp,"/who",4)) {
			_menu.handleMenuItem(CFMENU_OBUDDIES);
			return 0;
		}
		if (!strncasecmp(inp,"/chatters",9)) { 
			_menu.handleMenuItem(CFMENU_OCHATTERS);
			return 0;
		}
		if (!strncasecmp(inp,"/away",5)) {
			if ((ptr=strchr(inp,' '))==NULL) {
				_yp.setUserStatus();
				return 0;
			}
			while (*(++ptr)==' ');
			if (!*ptr)
				_yp.setUserStatus();
			else if (!strcmp(ptr,"brb"))
				_yp.setUserStatus(YH_USTAT_BRB);
			else if (!strcmp(ptr,"back"))
				_yp.setUserStatus();
			else if ((!strcmp(ptr,"busy")) || (!strcmp(ptr,"bsy")))
				_yp.setUserStatus(YH_USTAT_BSY);
			else if ((!strcmp(ptr,"not home")) || (!strcmp(ptr,"nhom")) ||
				(!strcmp(ptr,"nhome")))
				_yp.setUserStatus(YH_USTAT_NHOM);
			else if ((!strcmp(ptr,"not desk")) || (!strcmp(ptr,"ndsk")) ||
				(!strcmp(ptr,"ndesk")))
				_yp.setUserStatus(YH_USTAT_NDSK);
			else if ((!strcmp(ptr,"not office")) || (!strcmp(ptr,"nofc")) ||
				(!strcmp(ptr,"noffice")))
				_yp.setUserStatus(YH_USTAT_NOFC);
			else if ((!strcmp(ptr,"phone")) || (!strcmp(ptr,"fon")))
				_yp.setUserStatus(YH_USTAT_FON);
			else if ((!strcmp(ptr,"vacation")) || (!strcmp(ptr,"vaca")) ||
				(!strcmp(ptr,"vac")))
				_yp.setUserStatus(YH_USTAT_VACA);
			else if ((!strcmp(ptr,"lunch")) || (!strcmp(ptr,"lnch")))
				_yp.setUserStatus(YH_USTAT_LNCH);
			else if ((!strcmp(ptr,"stepped out")) || (!strcmp(ptr,"sout")) ||
				(!strcmp(ptr,"out")))
				_yp.setUserStatus(YH_USTAT_SOUT);
			else 
				_yp.setUserMiscStatus(YH_USTAT_CUST,ptr);
			return 0;
		}
		if (!strncasecmp(inp,"/tell ",6)) {
			if ((ptr = strchr(inp+6,' '))!=NULL) {
				StrList
					slist(false);
				string
					tmp;
				*ptr=0;
				_yp.sendPrivateMessage(inp+6,ptr+1);
				tmp=inp+6;
				slist.add(tmp);
				tmp=ptr+1;
				slist.add(tmp);
				_menu.handleMenuItem(CFMENU_OPMLOG,slist);
				return 0;
			}
		}
		if (!strncasecmp(inp,"/join ",6)) {
			ptr=strchr(inp,' ');
			while (*(++ptr)==' ');
			_yp.joinRoom(ptr);
			return 0;
		}
		if (!strncasecmp(inp,"/goto ",6)) {
			char *bptr;
			ptr=strchr(inp,' ');
			while (*(++ptr)==' ');
			if ((bptr = strchr(ptr,' '))!=NULL)
				*bptr=0;
			_yp.gotoUser(ptr);
			return 0;
		}
		if (!strncasecmp(inp,"/follow",7)) {
			StrList
				slist(false);
			if ((ptr=strchr(inp,' '))!=NULL) {
				char *bptr;
				while (*(++ptr)==' ');
				if ((bptr = strchr(ptr,' '))!=NULL)
					*bptr=0;
				if (*ptr) {
					string tmp=ptr;
					slist.add(tmp);
				}
			}
			_yp.setFollow(slist[0]);
			_menu.handleMenuItem(CFMENU_OFOLLOW,slist);
			return 0;
		}
		if (!strncasecmp(inp,"/invite ",8)) {
			char *bptr;
			ptr=strchr(inp,' ');
			while (*(++ptr)==' ');
			if ((bptr = strchr(ptr,' '))!=NULL)
				*bptr=0;
			_yp.sendInvite(ptr);
			return 0;
		}
		if (!strncasecmp(inp,"/think",6)) {
			if ((ptr=strchr(inp,' '))!=NULL) {
				*ptr=0;
			}
			else  {
				// hehe, this is such a hack
				ptr=lazy_hack;
			}
			_yp.sendThought(ptr+1);
			return 0;
		}
		if (!strncasecmp(inp,"/roll",5)) {
			if ((ptr=strchr(inp,' '))!=NULL) {
				*ptr=0;
			}
			else {
				//again, the pitifulness of myself... ;)
				ptr=lazy_hack;
			}
			_yp.rollDice(ptr+1);
			return 0;
		}
		if (!strncasecmp(inp,"/clear",6)) {
			_menu.handleMenuItem(CFMENU_CLRSCR);
			return 0;
		}
		if (!strncasecmp(inp,"/ignore",7)) {
			StrList
				slist;
			if ((ptr=strchr(inp,' '))!=NULL) {
				char *bptr;
				string tmp;

				while (*(++ptr)==' ');
				if ((bptr = strchr(ptr,' '))!=NULL)
					*bptr=0;
				tmp=ptr;
				//_yp.ignoreUser(ptr);
				slist.add(tmp);
			}
			_menu.handleMenuItem(CFMENU_OIGNORE,slist);
			return 0;
		}
		if (!strncasecmp(inp,"/unignore ",10)) {
			StrList
				slist;
			char *bptr;
			string tmp;

			ptr=strchr(inp,' ');
			while (*(++ptr)==' ');
			if ((bptr = strchr(ptr,' '))!=NULL)
				*bptr=0;
			tmp=ptr;
			//_yp.unignoreUser(tmp);
			slist.add(tmp);
			_menu.handleMenuItem(CFMENU_OUNIGNORE,slist);
			return 0;
		}
		if (!strncasecmp(inp,"/mute",5)) {
			StrList
				slist;
			if ((ptr=strchr(inp,' '))!=NULL) {
				char *bptr;
				string tmp;

				while (*(++ptr)==' ');
				if ((bptr = strchr(ptr,' '))!=NULL)
					*bptr=0;
				tmp=ptr;
				slist.add(tmp);
			}
			_menu.handleMenuItem(CFMENU_OMUTE,slist);
			return 0;
		}
		if (!strncasecmp(inp,"/unmute ",8)) {
			StrList
				slist;
			char *bptr;
			string tmp;

			ptr=strchr(inp,' ');
			while (*(++ptr)==' ');
			if ((bptr = strchr(ptr,' '))!=NULL)
				*bptr=0;
			tmp=ptr;
			slist.add(tmp);
			_menu.handleMenuItem(CFMENU_OUNMUTE,slist);
			return 0;
		}
		if (!strncasecmp(inp,"/profile",8)) {
			StrList
				slist;
			if ((ptr=strchr(inp,' '))!=NULL) {
				char *bptr;
				string tmp;

				while (*(++ptr)==' ');
				if ((bptr = strchr(ptr,' '))!=NULL)
					*bptr=0;
				tmp=ptr;
				slist.add(tmp);
			}
			_menu.handleMenuItem(CFMENU_OPROFILE,slist);
			return 0;
		}
		if (inp[0]==':') {
			StrUtil sutil;
			string tmp=inp;
			if (sutil.isSmiley(tmp)) {
				_yp.sendMessage(inp);
				return 0;
			}
			if (inp[0]==':')
				ptr=inp+1;
			else
				ptr=inp+4;
			_yp.sendEmote(ptr);
			return 0;
		}
		if ((inp[0]=='/') && (_commandlist)) {
			string
				message,
				command=inp+1;
			if (handleCustomCommand(command,message)) {
				strncpy(inp,message.c_str(),512);
				if (strlen(inp)>511) {
					inp[509]='.';
					inp[510]='.';
					inp[511]='.';
				}
				continue;
			}
		}

		// START BEM

		if (!strncasecmp(inp,"/act",4)) {
			_menu.handleMenuItem(CFMENU_OACTIVITY);
			return 0;
		}

		if (!strncasecmp(inp,"/pms",4)) {
			_menu.handleMenuItem(CFMENU_OPMS);
			return 0;
		}

		if (inp[0]=='/')
			return 0;

		// END BEM

		break;
	}
	_yp.sendMessage(inp);
	return 0;
}

int CFCommand::handleCustomCommand(const string &command, string &result) {
	StrList lst(false);
	string comm, value;
	
	parse(command,lst);
	comm=lst[0];
	if ((*_commandlist).inlist(comm)) {
		(*_commandlist).get(comm,value);
		replace(value,lst,result);
		return 1;
	}
	return 0;
}

int CFCommand::handleExecCommand(const string &command, string &result) {
	char 
		inp[576];
	int
		p[2],
		pid,
		chrs,
		len;

	pipe(p);
	strncpy(inp,command.c_str(),507);
	len=strlen(inp);
	strcat(inp," 2>&1");
	inp[len]=':';
	inp[len+1]='\n';
	inp[len+2]=0;
	chrs=len+2;
	if ((pid=fork())==-1) {
		result=command+": couldnt fork";
		return -1;
	}
	else if (pid) {
		int rv;
		unsigned long tlapsed=0;
		bool timedout=false;
		char *ptr;

		close(p[1]);
		int flags=fcntl(p[0],F_GETFL,0);
		rv=fcntl(p[0],F_SETFL,flags|O_NONBLOCK);
		ptr=inp+chrs;	
		while (chrs < 512) {
			if (tlapsed > MSecsToComplete) {
				timedout=true;
				break;
			}
			if ((rv=read(p[0],ptr, (512-chrs))) < 0) {
				rv=errno;
				if (rv==EINTR) {
					logger.log("EINTR");
					continue;
				}
				else if (rv == EAGAIN) {
					usleep(50000);
					tlapsed+=50000;			
					continue;
				}
				else {
					usleep(50000);
					tlapsed+=50000;			
					continue;
				}
			}
			else if (rv == 0) {
				break;
			}
			chrs+=rv;
			ptr+=rv;
			*ptr=0;
		}
		if (kill(pid,0)==0) {
			kill(pid,SIGKILL);
		}
		if (timedout)
			strcat(inp,"[process timed out]");
		if (chrs>511) {
			inp[509]='.';
			inp[510]='.';
			inp[511]='.';
		}
		result=inp;
		waitpid(pid,NULL,0);
	}
	else {
		close(p[0]);
		if (p[1] != STDOUT_FILENO) {
			dup2(p[1],STDOUT_FILENO);
			close (p[1]);
		}
		if (STDERR_FILENO != STDOUT_FILENO) {
			dup2(STDOUT_FILENO, STDERR_FILENO);
		}
		execlp("sh","sh","-c",command.c_str(),NULL);
	}
	return 0;
}

int CFCommand::parse(const string &line, StrList &lst) {
	char
		buf[line.length()+1],
		*ptr,
		*bptr;
	string tmp;

	strcpy(buf,line.c_str());
	ptr=buf;
	while ((ptr=strchr(ptr,0x09))!=NULL)
		*ptr=0x20;
	ptr=buf;
	while ((bptr=strchr(ptr,0x20))!=NULL) {
		*bptr=0x0;
		while (*(++bptr)==0x20);
		tmp=ptr;
		lst.add(tmp);
		ptr=bptr;
	}
	tmp=ptr;
	lst.add(tmp);
	return 0;
}

int CFCommand::replace(const string &line, const StrList &lst, string &result) {
	unsigned int i;
	int idx;
	result=line;
	for (i=0; i < 10; i++) {
		char buf[3];

		sprintf(buf,"$%d",i);
		while ((idx=result.find(buf)) > -1) {
			result.replace(idx,2,lst[i]);
		}
	}
	if ((idx=result.find("$*")) > -1) {
		string comp;
		for (i=1; i < lst.size(); i++) {
			if (comp.length())
				comp+=" ";
			comp+=lst[i];
		}
		while ((idx=result.find("$*")) > -1) {
			result.replace(idx,2,comp);
		}
	}
	return 0;
}
